// ARDUIPROJ_04_v2 (version avec potar)
/* Auteur: Brock Craft 
 *
 * Le Chenillard (The All-Seeing Eye)
 *
 * v0.3 02.02.2015
 * VF par OE 160617
*/

// Durée d'allumage de chaque LED
int delai = 240; 

// Indice de tableau pour la broche de la LED allumée
int LEDcourante = 4;

// Sens du chenillard +1 ou -1
int sens = 1;

// Dernière référence temporelle de début d'allumage
unsigned long heureModif = 0;

// Tableau de numéros de broches de LED
byte numBroche[] = {4, 5, 6, 7, 8, 9, 10, 11, 12, 13};

void setup() {
  // Configure les broches en sortie
  for (int x=0; x<10; x++) {
    pinMode(numBroche[x], OUTPUT); 
  }
 // 1ère référence temporelle 
  heureModif = millis();
}

void loop() {
  // Fin de durée d'allumage ?
  if ((millis() - heureModif) > delai) {

    // Tout éteindre
    for (int x=0; x<10; x++) {
      digitalWrite(numBroche[x], LOW);
    }

    // Allumer une LED
    digitalWrite(numBroche[LEDcourante], HIGH);

    // Passer à l'indice suivant/précédent
    LEDcourante += sens;

    // Si en butée, demi-tour
    if (LEDcourante == 9) {
      sens = -1;
    }
    if (LEDcourante == 0) {
      sens = 1;
    }

  // Nouvelle référence temporelle
  heureModif = millis();
  }
  delai = analogRead(0); // Ajout version 2 avec potar
  delay(5);              // Pour stabiliser la lecture
}


