// ARDUIPROJ_05_v2 (Seconde version)
/* Auteur: Brock Craft 
 *
 * Lux, le compagnon
 * Joue sur la luminosité de 3 LED
 * pour exprimer trois humeurs 
 *
 * v0.1 30.04.2013
 * VF OE 1606
*/

// Broches de commande des LED
const int broLED_R = 9;
const int broLED_V = 10;
const int broLED_B = 11;

// Trois couples de variables pour la brillance actuelle et future
int briRouge = 0;    // Brillance actuelle
int briFutRouge = 0; // Brillance future

int briBleue = 0;
int briFutBleue = 0;

int briVerte = 0;
int briFutVerte = 0;

// Vitesse de changement de brillance
int viteBrille = 50;

// Code de l'humeur et durée
int humeur = 0;
const int dureeHumeur = 10000; // Soit 10 secondes d'humeur

// Configurons les broches en mode sortie
void setup(){
  pinMode(broLED_R, OUTPUT);
  pinMode(broLED_B, OUTPUT);
  pinMode(broLED_V, OUTPUT);
}

// Boucle principale pour choisir la prochaine humeur
void loop() {
  // Tirage au sort
  humeur = random(20); // Entre 0 et 19
  if (humeur == 0){    // Si 0, on appelle caliner()
    caliner(); 
  }
  if (humeur == 1){    // Si 1, on appelle seRejouir()
    seRejouir();
  }
  if (humeur == 2){    // Si 2, on appelle bouder()
    bouder(); 
  }
  if (humeur > 2){     // Si un autre nombre, variation douce
    balayerCouleurs(); 
  }
}

void balayerCouleurs(){

  // Tirage au sort nlle brillance LED rouge
  briFutRouge= random(255); 
  if (briRouge < briFutRouge){
    for (int x=briRouge; x < briFutRouge; x++) {
      analogWrite(broLED_R, x);
      delay(viteBrille);
    }
  } 
  else {
    for (int x=briRouge; x > briFutRouge; x--) {
      analogWrite(broLED_R, x);
      delay(20);      
      delay(viteBrille);    
    } 
  }
  briRouge = briFutRouge;

  // Tirage au sort nlle brillance LED verte
  briFutVerte= random(255);
  if (briVerte < briFutVerte){
    for (int x=briVerte; x < briFutVerte; x++) {
      analogWrite(broLED_V, x);
      delay(viteBrille);
    }
  } 
  else {
    for (int x=briVerte; x > briFutVerte; x--) {
      analogWrite(broLED_V, x);
      delay(viteBrille);
    } 
  }
  briVerte = briFutVerte;

  // Tirage au sort nlle brillance LED bleue
  briFutBleue= random(255);
  if (briBleue < briFutBleue){
    for (int x=briBleue; x < briFutBleue; x++) {
      analogWrite(broLED_B, x);
      delay(viteBrille);
    }
  } 
  else {
    for (int x=briBleue; x > briFutBleue; x--) {
      analogWrite(broLED_B, x);
      delay(viteBrille);
    } 
  }
  briBleue = briFutBleue;
}


  // Dix pulsations câlines des trois LED
void caliner(){
  for (int cCalin = 0; cCalin < 10; cCalin++){
    for(int x = 0; x < 255; x++){
      analogWrite(broLED_R, x);
      analogWrite(broLED_V, x);     
      analogWrite(broLED_B, x);
      delay(10);
    }
    for(int x = 255; x > 0; x--){
      analogWrite(broLED_R, x);
      analogWrite(broLED_V, x);     
      analogWrite(broLED_B, x);
      delay(10);
    }
  }
}

// Vert est la couleur du bonheur
void seRejouir(){
  for(int x = briVerte; x < 255; x++){
    analogWrite(broLED_V, x);
    delay(viteBrille);
  }
  for(int x = briRouge; x > 0; x--){
    analogWrite(broLED_R, x);
    delay(viteBrille);
  }
  for(int x = briBleue; x > 0; x--){
    analogWrite(broLED_B, x);
    delay(viteBrille);
  }
  delay(dureeHumeur); // Le programme patiente...
  for(int x = 255; x > 0; x--){
    analogWrite(broLED_V, x);
    delay(viteBrille);
  }
}

// Rouge de tristesse mais ne dure que dureeHumeur
void bouder(){
  for(int x = briRouge; x < 255; x++){
    analogWrite(broLED_R, x);
    delay(viteBrille);
  }
  for(int x = briVerte; x > 0; x--){
    analogWrite(broLED_V, x);
    delay(viteBrille);
  }
  for(int x = briBleue; x > 0; x--){
    analogWrite(broLED_B, x);
    delay(viteBrille);
  }
  delay(dureeHumeur); // Le programme patiente...
  for(int x = 255; x > 0; x--){
    analogWrite(broLED_R, x);
    delay(viteBrille);
  }
} 
// FIN
