// ARDUIPROJ_06_v3 (message)
/* Auteur: Brock Craft 
 *
 * Afficheur épeleur
 * Affiche sur une matrice de LED
 *
 * v0.1 30.04.2013
 * Adapté de Oomlout.com http://www.tinyurl.com/yhwxv6h
 * VF OE 1606
*/

char message[] = "Bonjour ! ";  // The message !

// Variables de gestion du défilement (commencent à 0)
int index = 0;  // Caractère du message en cours
int offset = 0; // Décalage horizontal

// Lettres
const int A = 0;  const int B = 1;  const int C = 2;  const int D = 3;  const int E = 4;
const int F = 5;  const int G = 6;  const int H = 7;  const int I = 8;  const int J = 9;  
const int K = 10; const int L =11;  const int M = 12; const int N = 13; const int O = 14; 
const int P = 15; const int Q =16;  const int R = 17; const int S = 18; const int T = 19; 
const int U = 20; const int V =21;  const int W = 22; const int X = 23; const int Y = 24; 
const int Z = 25;

// Ponctuation
const int COL =26; const int DASH = 27; const int BRA2 = 28; const int  _ = 29; const int LINE = 34;
const int DOT =36;

// Autres signes
const int  FULL =30; const int CHECK = 31; const int B2 = 32; const int TEMP = 33; 
const int SMILE =35; const int COLDOT = 36;

// Broches des lignes et colonnes
int broLigne[] = {2,3,4,5,6,7,8,9};
int broColon[] = {17,16,15,14,13,12,11,10};

// Tableau du ou des deux symboles en cours d'affichage
// (intervenir ici pour un autre effet que le 
// défilement latéral)
byte data[] = {0,0,0,0,0,0,0,0};        

// L'alphabet anglais
// Chaque signe est sur 7 bits de large en 8 de haut
const int _A[] = {B0001000,
                  B0010100,
                  B0100010,
                  B1000001,
                  B1111111,
                  B1000001,
                  B1000001,
                  B0000000};

const int _B[] = {B1111110,
                  B0100001,
                  B0100001,
                  B0111110,
                  B0100001,
                  B0100001,
                  B1111110,
                  B0000000};

const int _C[] = {B0011111,
                  B0100000,
                  B1000000,
                  B1000000,
                  B1000000,
                  B0100000,
                  B0011111,
                  B0000000};

const int _D[] = {B1111100,
                  B0100010,
                  B0100001,
                  B0100001,
                  B0100001,
                  B0100010,
                  B1111100,
                  B0000000};

const int _E[] = {B1111111,
                  B1000000,
                  B1000000,
                  B1111100,
                  B1000000,
                  B1000000,
                  B1111111,
                  B0000000};

const int _F[] = {B1111111,
                  B1000000,
                  B1000000,
                  B1111100,
                  B1000000,
                  B1000000,
                  B1000000,
                  B0000000};

const int _G[] = {B0011111,
                  B0100000,
                  B1000000,
                  B1001111,
                  B1000001,
                  B0100001,
                  B0011111,
                  B0000000};

const int _H[] = {B1000001,
                  B1000001,
                  B1000001,
                  B1111111,
                  B1000001,
                  B1000001,
                  B1000001,
                  B0000000};

const int _I[] = {B1111111,
                  B0001000,
                  B0001000,
                  B0001000,
                  B0001000,
                  B0001000,
                  B1111111,
                  B0000000};

const int _J[] = {B0001111,
                  B0000001,
                  B0000001,
                  B0000001,
                  B0000001,
                  B1000001,
                  B0111110,
                  B0000000};

const int _K[] = {B1000011,
                  B1000100,
                  B1001000,
                  B1110000,
                  B1001000,
                  B1000100,
                  B1000011,
                  B0000000};

const int _L[] = {B1000000,
                  B1000000,
                  B1000000,
                  B1000000,
                  B1000000,
                  B1000000,
                  B1111111,
                  B0000000};

const int _M[] = {B1110110,
                  B1001001,
                  B1001001,
                  B1001001,
                  B1001001,
                  B1001001,
                  B1001001,
                  B0000000};

const int _N[] = {B1000001,
                  B1100001,
                  B1010001,
                  B1001001,
                  B1000101,
                  B1000011,
                  B1000001,
                  B0000000};

const int _O[] = {B0011100,
                  B0100010,
                  B1000001,
                  B1000001,
                  B1000001,
                  B0100010,
                  B0011100,
                  B0000000};

const int _P[] = {B0111110,
                  B0100001,
                  B0100001,
                  B0111110,
                  B0100000,
                  B0100000,
                  B0100000,
                  B0000000};

const int _Q[] = {B0011100,
                  B0100010,
                  B1000001,
                  B1000001,
                  B1000101,
                  B0100010,
                  B0011101,
                  B0000000};

const int _R[] = {B1111110,
                  B0100001,
                  B0100001,
                  B0101110,
                  B0100100,
                  B0100010,
                  B0100001,
                  B0000000};

const int _S[] = {B0111111,
                  B1000000,
                  B1000000,
                  B0111110,
                  B0000001,
                  B0000001,
                  B1111110,
                  B0000000};

const int _T[] = {B1111111,
                  B0001000,
                  B0001000,
                  B0001000,
                  B0001000,
                  B0001000,
                  B0001000,
                  B0000000};

const int _U[] = {B1000001,
                  B1000001,
                  B1000001,
                  B1000001,
                  B1000001,
                  B1000001,
                  B0111110,
                  B0000000};

const int _V[] = {B1000001,
                  B1000001,
                  B1000001,
                  B1000001,
                  B0100010,
                  B0010100,
                  B0001000,
                  B0000000};
                  
const int _W[] = {B1000001,
                  B1001001,
                  B1001001,
                  B1001001,
                  B1001001,
                  B1001001,
                  B0110110,
                  B0000000};

const int _X[] = {B1000001,
                  B0100010,
                  B0010100,
                  B0001000,
                  B0010100,
                  B0100010,
                  B1000001,
                  B0000000};

const int _Y[] = {B1000001,
                  B0100010,
                  B0010100,
                  B0001000,
                  B0001000,
                  B0001000,
                  B0001000,
                  B0000000};

const int _Z[] = {B1111111,
                  B0000010,
                  B0000100,
                  B0111110,
                  B0010000,
                  B0100000,
                  B1111111,
                  B0000000};

const int _COL[] ={B0000000,
                   B0011000,
                   B0011000,
                   B0000000,
                   B0011000,
                   B0011000,
                   B0000000,
                   B0000000};

const int _DASH[] = {B0000000,
                     B0000000,
                     B0000000,
                     B0111110,
                     B0000000,
                     B0000000,
                     B0000000,
                     B0000000};

const int _BRA2[] = {B0010000,
                     B0001000,
                     B0000100,
                     B0000100,
                     B0001000,
                     B0010000,
                     B0000000,
                     B0000000};                  

const int __[] = {B0000000,
                  B0000000,
                  B0000000,
                  B0000000,
                  B0000000,
                  B0000000,
                  B0000000,
                  B0000000};

const int _FULL[] = {B1111111,
                     B1111111,
                     B1111111,
                     B1111111,
                     B1111111,
                     B1111111,
                     B1111111,
                     B0000000};                  

const int _CHECK[] = {B1010101,
                      B0101010,
                      B1010101,
                      B0101010,
                      B1010101,
                      B0101010,
                      B1010101,
                      B0000000};
                  
const int _B2[] = {B0111110,
                   B0000001,
                   B0000001,
                   B0001111,
                   B0000001,
                   B1000001,
                   B0111110,
                   B0000000};

const int _TEMP[] = {B0000011,
                     B0011111,
                     B0111111,
                     B1111110,
                     B1111111,
                     B0011111,
                     B0000011,
                     B0000000};

const int _LINE[] = {B0000001,
                     B0000001,
                     B0000001,
                     B0000001,
                     B0000001,
                     B0000001,
                     B0000001,
                     B0000000};                     
                 
const int _SMILE[] = {B0000000,
                      B1100100,
                      B1100010,
                      B0011001,
                      B1100010,
                      B1100100,
                      B0000000,
                      B0000000};                     
                  

const int _DOT[] = {B0000000,
                    B0000000,
                    B0000000,
                    B0000000,
                    B1100000,
                    B1100000,
                    B0000000,
                    B0000000};                     
                  
const int _COLDOT[] = {B0000000,
                       B0110000,
                       B0110000,
                       B0000000,
                       B0110011,
                       B0110011,
                       B0000000,
                       B0000000};                  

// (le motif du _A est à l'indice 0 and A = 0 donc lettres[A] rapporte le motif 'A'.)
const int * lettres[] = {_A,_B,_C,_D,_E,_F,_G,_H,_I,_J,_K,_L,_M,_N,_O,_P,_Q,_R,_S,_T,_U,_V,_W,_X,_Y,_Z,
_COL,_DASH,_BRA2,__, _FULL, _CHECK, _B2, _TEMP, _LINE, _SMILE, _DOT, _COLDOT};

const int puiss2[] = {1,2,4,8,16,32,64,128};

void setup()
{ 
  for(int i = 0; i <8; i++){  // Broches de matrice en sortie
    pinMode(broLigne[i], OUTPUT);
    pinMode(broColon[i], OUTPUT);
  }
}
 
void loop()
{
  chargerLutin();
  afficherLutin(data, 40);  // Délai réglable
}

// Charge le cadre d'affichage dans data[]
void chargerLutin(){
  int carCour = getChar(message[index]);
  int carSuiv = getChar(message[index+1]);
  
  for(int lig=0; lig < 8; lig++){  
    data[lig] = 0; 
    for(int col=0; col < 8; col++){ 
     data[lig] = data[lig] + ((puiss2[col] & (lettres[carCour][lig] << offset    ))); 
     data[lig] = data[lig] +  (puiss2[col] & (lettres[carSuiv][lig] >> (8-offset) ));
    }
  }
  offset++;
  if(offset==8){offset = 0; index++; if(index==sizeof(message)-2){index=0;}}
}

void afficherLutin(byte * data, unsigned long duration){
  unsigned long start = millis();
  while (start+duration>millis()){
  for(int col = 0; col < 8; col++){
   for(int i = 0; i < 8; i++){                         
       digitalWrite(broLigne[i], LOW);   
   }
   for(int i = 0; i < 8; i++){ 
     if(i == col){
     digitalWrite(broColon[i], LOW);
     } 
     else{
     digitalWrite(broColon[i], HIGH); } 
   }

   for(int lig = 0; lig < 8; lig++){ 
    int bit = (data[col] >> lig) & 1;
    if(bit == 1){ 
       digitalWrite(broLigne[lig], HIGH);
    }
   }
  } 
 }
}


// Renvoie l'index d'un caractère.
// Pour passer d'une chaîne à un indice
// dans le tableau géant des motifs.

int getChar(char signe){
 int valRetour = CHECK;
 switch(signe){
  case 'A': valRetour = A; break;
  case 'a': valRetour = A; break;
  case 'B': valRetour = B; break;
  case 'b': valRetour = B; break;
  case 'C': valRetour = C; break;
  case 'c': valRetour = C; break;
  case 'D': valRetour = D; break;
  case 'd': valRetour = D; break;
  case 'E': valRetour = E; break;
  case 'e': valRetour = E; break;
  case 'F': valRetour = F; break;
  case 'f': valRetour = F; break;
  case 'G': valRetour = G; break;
  case 'g': valRetour = G; break;
  case 'H': valRetour = H; break;
  case 'h': valRetour = H; break;
  case 'I': valRetour = I; break;
  case 'i': valRetour = I; break;
  case 'J': valRetour = J; break;
  case 'j': valRetour = J; break;
  case 'K': valRetour = K; break;
  case 'k': valRetour = K; break;
  case 'L': valRetour = L; break;
  case 'l': valRetour = L; break;
  case 'M': valRetour = M; break;
  case 'm': valRetour = M; break;
  case 'N': valRetour = N; break;
  case 'n': valRetour = N; break;
  case 'O': valRetour = O; break;
  case 'o': valRetour = O; break;
  case 'P': valRetour = P; break;
  case 'p': valRetour = P; break;
  case 'Q': valRetour = Q; break;
  case 'q': valRetour = Q; break;
  case 'R': valRetour = R; break;
  case 'r': valRetour = R; break;
  case 'S': valRetour = S; break;
  case 's': valRetour = S; break;
  case 'T': valRetour = T; break;
  case 't': valRetour = T; break;
  case 'U': valRetour = U; break;
  case 'u': valRetour = U; break;
  case 'V': valRetour = V; break;
  case 'v': valRetour = V; break;
  case 'W': valRetour = W; break;
  case 'w': valRetour = W; break;
  case 'X': valRetour = X; break;
  case 'x': valRetour = X; break;
  case 'Y': valRetour = Y; break;
  case 'y': valRetour = Y; break;
  case 'Z': valRetour = Z; break;
  case 'z': valRetour = Z; break;
  case ' ': valRetour = _; break;
  
  // Signes de ponctuation
  case '3': valRetour = B2; break;
  case '<': valRetour = TEMP; break;
  case '*': valRetour = FULL; break;
  case '|': valRetour = LINE; break;  
  case '_': valRetour = _; break;  
  case ':': valRetour = COL; break;  
  case '-': valRetour = DASH; break;  
  case ')': valRetour = BRA2; break;  
  case '%': valRetour = SMILE; break;  
  case '.': valRetour = DOT; break;    
  case '^': valRetour = COLDOT; break;      
  }
  return valRetour;
}
