// APPN11_Chatiere_V2
/* Auteur : Brock Craft 
 *
 * Chatière tweeteuse
 *
 * Exploite les librairies standard SPI, Ethernet, EEPROM,
 * SHA, Time et celles pour Arduino Twitter de Markku Rossi.
 *
 * v0.1 30.04.2013
 * VF par OE 160626
*/

#include <SPI.h>         
#include <Ethernet.h>
#include <EEPROM.h>
#include <sha1.h>
#include <Time.h>
#include <Twitter.h>

// Fournir une adresse MAC pour le controleur.
// Sur les cartes recentes, elle est sur une etiquette sur la carte.
byte mac[] = { 0x90, 0xA2, 0xDA, 0x0D, 0x4A, 0x39 };
IPAddress ip(192,168,1,21); // Spécifique à votre réseau local
EthernetClient client;

IPAddress twitter_ip(199, 59, 149, 232);
uint16_t  twitter_port = 80;

// Indiquez ici votre CONSUMER KEY et SECRET obtenus sur Twitter!
const static char consumer_key[] PROGMEM = "k3fzKEsLNY7KvtddYB1aw9Bs6"; // *****VOTRE CONSUMER KEY*****
const static char consumer_secret[] PROGMEM = "61j8Y0ldtQ1e4UrFHMnblVBSV67zVqPoHkBZ7RnJt9nrZ65Blh"; //*****VOTRE CONSUMER SECRET*****

char buffer[512];
Twitter twitter(buffer, sizeof(buffer));

unsigned long horodat;
boolean bRetour = false;
char* msgRevenu = "Me voici revenu.";
char* msgSorti  = "Je sors un peu.";

const int broRevenu = A0;
const int broSorti  = A1;
int valRevenu = 0;
int valSorti = 0;

void setup() {
  Serial.begin(9600);       
  Serial.println("Demande d'adresse IP via DHCP...");
  if (!Ethernet.begin(mac)) {
    // Si DHCP échoue, on prend une adresse fixe:
    Serial.println("Pas de DHCP, donc IP statique:");
    Ethernet.begin(mac, ip);
  }
  Serial.print("Mon adresse:");
  Serial.println(Ethernet.localIP());
  delay(3000); // Pause pour lire la valeur sur le Moniteur 
  
  pinMode(broRevenu, INPUT); 
  pinMode(broSorti, INPUT);  

  // Connexion à Twitter.
  // Ici appel qui ne fonctionne pas dans la version actuelle.
  twitter.set_twitter_endpoint( PSTR("api.twitter.com"), PSTR("/1/statuses/update.json"), twitter_ip, twitter_port, false); 
  // Lecture OAuth account identification dans EEPROM. 
  twitter.set_client_id(consumer_key, consumer_secret);
  // Configure OAuth account identification depuis la mémoire du programme. 
  
  // A remplacer par votre ACCESS TOKEN et SECRET de Twitter!
  twitter.set_account_id(PSTR("12499431-Dgo9ihVyW9qtcl72aoyOzn2JZabmz24tPH3BLAIq9"),
  PSTR("Px5NSr749ze1nMS0Ko2tRJe4gpy49j65eknLa3fd41B0I"));
}

void loop(){
  valRevenu = analogRead(broRevenu);
  
  Serial.println(valRevenu);
  
  if (valRevenu < 5) { //oe 50
    bRetour=true;
    posterTweet();
  }

  valSorti = analogRead(broSorti); 
  if (valSorti < 5) { //oe 50
    bRetour=false;
    posterTweet();
  }
  delay(10000); //oe 10
}

void posterTweet(){
  if (twitter.is_ready())  {
    char tweet[140];
    horodat = twitter.get_time();
       
    if(bRetour){
      sprintf(tweet, "%02d:%02d:%02d: %s", hour(horodat), minute(horodat), second(horodat), msgRevenu);
    } else {
      sprintf(tweet, "%02d:%02d:%02d: %s", hour(horodat), minute(horodat), second(horodat), msgSorti);
    }
   
    Serial.println(tweet);
    Serial.print("Postons sur Twitter: ");
    if (twitter.post_status(tweet)){
      Serial.println("Statut actualisé");
    }
    else{
      Serial.println("Echec Update");
    }
  }
  delay(10000);  // Pause de 10 sec pour que la porte ne batte plus
}

